(* Flipboard

Ver, 1.00 2013/03/16 ꉞB
Ver, 1.01 2013/07/25 vCx[gNbv{[htH[}bg FormatLst ɗ񋓂悤ǉB
Ver, 1.02 2014/10/05 JVNVU#97910946 Ǝ㐫΍B
Ver, 1.03 2014/10/17 JVNVU#97910946 Ǝ㐫΍ǉB
Ver, 1.04 2016/11/13 Delphi10.1 ɈڍsBSʓIɏB
Ver, 1.05 2017/10/22 CuXVBTClipboardStream.GetTitle CBTConfigDialog ύXB
Ver, 1.06 2018/02/04 CuXVB
Ver, 1.07 2018/12/16 Delphi10.2 ɈڍsBWin10 ɒB
Ver, 1.08 2019/03/24 Delphi10.3 ɈڍsBƁA 10.3 BfXNgbvTCY̕ύXɑΉB
Ver, 1.09 2021/06/05 CuXVƑSʓIȏB

   windowsFLIP like clipBOARD extension *)

program Flipboard;

uses
  Vcl.Forms,
  Winapi.Windows,
  FLPBD_Switch in 'FLPBD_Switch.pas' {SwitchForm},
  FLPBD_Config in 'FLPBD_Config.pas' {ConfigDialog},
  FLPBD_Exit in 'FLPBD_Exit.pas' {ExitDialog};

{$R *.res}

const
  StateID = '{FDBAA36A-7EAC-43EA-AD48-9CFFFFFA8A7A}';

var
  RunningState: THandle;

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF DEBUG}
  //dN}~B
  RunningState := CreateMutex(nil, False, PChar(StateID));
  if RunningState <> 0 then
  begin
    try
      if GetLastError <> ERROR_ALREADY_EXISTS then
      begin
        Application.Initialize;
        Application.MainFormOnTaskbar := True;
        Application.CreateForm(TSwitchForm, SwitchForm);
        Application.CreateForm(TConfigDialog, ConfigDialog);
        Application.CreateForm(TExitDialog, ExitDialog);
        Application.Run;
      end
      //! else MessageBox(0, 'Mutex already exists', 'Flipboard', MB_OK or MB_ICONERROR);
    finally
      CloseHandle(RunningState);
    end;
  end
  else
    MessageBox(0, 'Mutex creation failed', 'Flipboard', MB_OK or MB_ICONERROR);
end.
