(*	HotKeys

Ver,1.00 2007/10/31 ^B
Ver,1.01 2013/03/16 CompareFront JB
Ver,1.02 2016/09/13 XE3 ȍ~ɏCB
Ver,1.03 2018/12/16 RpCwߕύXiʌ݊JbgjB
Ver,1.04 2021/03/29 zbgL[[`ύXEǉB

WinL[T|[gVXeChiO[ojzbgL[֘AR|[lgƃ[`WB

Routine
function  HotKey;				  VXeChzbgL[쐬BႢœށB
function  HotKeyToText;		zbgL[\𓾂B
function  CompareFront;   ̐擪rAv؂oB
function  TextToHotKey;		񂩂zbgL[쐬B
procedure HotKeyToKey;    zbgL[̃L[R[hƏCL[ԂBႢœށB
function  GetModifyState; CL[̉Ԃ TModifyState ŕԂB
function  GetModifyKeys:  CL[̉Ԃ Word ŕԂB

TGlobalHotkey
WinL[T|[g THotKey R|[lgB

vpeB
HotKey;	zbgL[BWinL[gȊO ShortCut vpeBƓB

\bh
ClearHotKey;	ݒ肳ĂzbgL[폜B

LȊÕvpeBA\bhACxg THotKey ƓB

TGlobalHotkeyAction
O[ozbgL[ɑΉANVR|[lgB

vpeB
HotKey;	O[ozbgL[B

LȊÕvpeBA\bhACxg TAction ƓB

	system-wide hot key ctrls and routine*)

unit Hotkeys;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Vcl.StdCtrls,
  Vcl.ActnList, System.Actions, Vcl.Forms, Vcl.Consts;

type
  TModifyState = set of (msShift, msCtrl, msAlt, msWin);

resourcestring
  SmkcLWin = 'Win';
  SmkcRWin = 'Win';
  SmkcWin = 'Win+';

const
  hcShift = $2000;
  hcCtrl = $4000;
  hcAlt = $8000;
  hcWin = $1000;
  hcNone = 0;

{ Hotkey Routine }

function HotKey(Key: Word; Modify: TModifyState): TShortCut; overload;
function HotKey(Key, Modify: Word): TShortCut; overload;
function HotKeyToText(ShortCut: TShortCut): string;
function CompareFront(var Text: string; const Front: string): Boolean;
function TextToHotKey(Text: string): TShortCut;
procedure HotKeyToKey(ShortCut: TShortCut; var Key: Word; var Modify: TModifyState); overload;
procedure HotKeyToKey(ShortCut: TShortCut; var Key, Modify: Word); overload;
function GetModifyState: TModifyState;
function GetModifyKeys: Word;

type
  THotKeyCap = (
    hkcBkSp, hkcTab, hkcEsc, hkcEnter, hkcSpace, hkcPgUp,
    hkcPgDn, hkcEnd, hkcHome, hkcLeft, hkcUp, hkcRight, hkcDown, hkcIns,
    hkcDel, hkcShift, hkcCtrl, hkcAlt,
    hkcLWin, hkcRWin, hkcWin);

const
  HotKeyCaps: array[THotKeyCap] of string = (
    SmkcBkSp, SmkcTab, SmkcEsc, SmkcEnter, SmkcSpace, SmkcPgUp,
    SmkcPgDn, SmkcEnd, SmkcHome, SmkcLeft, SmkcUp, SmkcRight, SmkcDown, SmkcIns,
    SmkcDel, SmkcShift, SmkcCtrl, SmkcAlt,
    SmkcLWin, SmkcRWin, SmkcWin);

type

{ TGlobalHotkey }

  TGlobalHotkey = class(TCustomEdit)
  private
    { Private 錾 }
    FHotKey: TShortCut;
    procedure SetHotKey(Value: TShortCut);
  protected
    { Protected 錾 }
    procedure DoEnter; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure Change; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    procedure ClearHotKey;
  published
    { Published 錾 }
    property HotKey: TShortCut read FHotKey write SetHotKey default 0;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Constraints;
    property Enabled;
    property Hint;
    property ParentBiDiMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnContextPopup;
    property OnEnter;
    property OnExit;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
  end;

{ TGlobalHotkeyAction }

  TGlobalHotkeyAction = class(TAction)
  private
    { Private 錾 }
    FHandle:HWND;
    FRegistered: Boolean;
    FHotKey: TShortCut;
    procedure SetHotKey(Value: TShortCut);
    procedure InstallHotKey(ShortCut: TShortCut);
    procedure UninstallHotKey;
  protected
    { Protected 錾 }
    procedure WndProc(var Message: TMessage);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Registered: Boolean read FRegistered;
  published
    { Published 錾 }
    property HotKey: TShortCut read FHotKey write SetHotKey default 0;
  end;

procedure Register;

implementation

{ Hotkey Routine }

// VXeChzbgL[쐬
function HotKey(Key: Word; Modify: TModifyState): TShortCut;
begin
  Result := 0;
  if WordRec(Key).Hi <> 0 then Exit;
  Result := Key;
  if msShift in Modify then Inc(Result, hcShift);
  if msCtrl in Modify then Inc(Result, hcCtrl);
  if msAlt in Modify then Inc(Result, hcAlt);
  if msWin in Modify then Inc(Result, hcWin);
end;

function HotKey(Key, Modify: Word): TShortCut;
begin
  Result := 0;
  if WordRec(Key).Hi <> 0 then Exit;
  Result := Key;
  if Modify and MOD_SHIFT <> 0 then Inc(Result, hcShift);
  if Modify and MOD_CONTROL <> 0 then Inc(Result, hcCtrl);
  if Modify and MOD_ALT <> 0 then Inc(Result, hcAlt);
  if Modify and MOD_WIN <> 0 then Inc(Result, hcWin);
end;

// zL[̖̂𓾂
function GetSpecialName(ShortCut: TShortCut): string;
var
  ScanCode: Integer;
  KeyName: array[0..255] of Char;
begin
  Result := '';
  ScanCode := MapVirtualKey(WordRec(ShortCut).Lo, 0) shl 16;
  if ScanCode <> 0 then
  begin
    GetKeyNameText(ScanCode, KeyName, SizeOf(KeyName));
    Result := KeyName;
  end;
end;

// zbgL[\𓾂
function HotKeyToText(ShortCut: TShortCut): string;
var
  Name: string;
begin
  case WordRec(ShortCut).Lo of
    $08, $09:
      Name := HotKeyCaps[THotKeyCap(Ord(hkcBkSp) + WordRec(ShortCut).Lo - $08)];
    $0D: Name := HotKeyCaps[hkcEnter];
    $1B: Name := HotKeyCaps[hkcEsc];
    $20..$28:
      Name := HotKeyCaps[THotKeyCap(Ord(hkcSpace) + WordRec(ShortCut).Lo - $20)];
    $2D..$2E:
      Name := HotKeyCaps[THotKeyCap(Ord(hkcIns) + WordRec(ShortCut).Lo - $2D)];
    $30..$39: Name := Chr(WordRec(ShortCut).Lo - $30 + Ord('0'));
    $41..$5A: Name := Chr(WordRec(ShortCut).Lo - $41 + Ord('A'));
    $5B: Name := HotKeyCaps[hkcLWin];
    $5C: Name := HotKeyCaps[hkcRWin];
    $60..$69: Name := Chr(WordRec(ShortCut).Lo - $60 + Ord('0'));
    $70..$87: Name := 'F' + IntToStr(WordRec(ShortCut).Lo - $6F);
  else
    Name := GetSpecialName(ShortCut);
  end;
  if Name <> '' then
  begin
    Result := '';
    if ShortCut and hcShift <> 0 then Result := Result + HotKeyCaps[hkcShift];
    if ShortCut and hcCtrl <> 0 then Result := Result + HotKeyCaps[hkcCtrl];
    if ShortCut and hcAlt <> 0 then Result := Result + HotKeyCaps[hkcAlt];
    if ShortCut and hcWin <> 0 then Result := Result + HotKeyCaps[hkcWin];
    Result := Result + Name;
  end
  else
  begin
    Result := '';
  end;
end;

// ̐擪rAv؂o
function CompareFront(var Text: string; const Front: string): Boolean;
begin
  Result := False;
  if (Length(Text) >= Length(Front)) and
    (AnsiStrLIComp(PChar(Text), PChar(Front), Length(Front)) = 0) then
  begin
    Result := True;
    Delete(Text, 1, Length(Front));
  end;
end;

// 񂩂zbgL[쐬
function TextToHotKey(Text: string): TShortCut;
var
  Key: TShortCut;
  Modify: TShortCut;
begin
  Result := 0;
  Modify := 0;
  while True do
  begin
    if CompareFront(Text, HotKeyCaps[hkcShift]) then Modify := Modify or hcShift
    else if CompareFront(Text, '^') then Modify := Modify or hcCtrl
    else if CompareFront(Text, HotKeyCaps[hkcCtrl]) then Modify := Modify or hcCtrl
    else if CompareFront(Text, HotKeyCaps[hkcAlt]) then Modify := Modify or hcAlt
    else if CompareFront(Text, HotKeyCaps[hkcWin]) then Modify := Modify or hcWin
    else Break;
  end;
  if Text = '' then Exit;
  for Key := $08 to $255 do
    if AnsiSameText(Text, HotKeyToText(Key)) then
    begin
      Result := Key or Modify;
      Exit;
    end;
end;

// zbgL[̃L[R[hƏCL[Ԃ
procedure HotKeyToKey(ShortCut: TShortCut; var Key: Word; var Modify: TModifyState);
begin
  Key := ShortCut and not (hcShift + hcCtrl + hcAlt + hcWin);
  Modify := [];
  if ShortCut and hcShift <> 0 then Include(Modify, msShift);
  if ShortCut and hcCtrl <> 0 then Include(Modify, msCtrl);
  if ShortCut and hcAlt <> 0 then Include(Modify, msAlt);
  if ShortCut and hcWin <> 0 then Include(Modify, msWin);
end;

procedure HotKeyToKey(ShortCut: TShortCut; var Key, Modify: Word);
var
  VK: Word;
  MS: TModifyState;
begin
  HotKeyToKey(ShortCut, VK, MS);
  Key := 0;
  case VK of
    VK_SHIFT: Include(MS, msShift);
    VK_CONTROL: Include(MS, msCtrl);
    VK_MENU: Include(MS, msAlt);
    VK_LWIN, VK_RWIN: Include(MS, msWin);
  else
    Key := VK;
  end;
  Modify := 0;
  if msShift in MS then Inc(Modify, MOD_SHIFT);
  if msCtrl in MS then Inc(Modify, MOD_CONTROL);
  if msAlt in MS then Inc(Modify, MOD_ALT);
  if msWin in MS then Inc(Modify, MOD_WIN);
end;

// CL[̉ԂԂ
function GetModifyState: TModifyState;
begin
  Result := [];
  if GetKeyState(VK_SHIFT) < 0 then Include(Result, msShift);
  if GetKeyState(VK_CONTROL) < 0 then Include(Result, msCtrl);
  if GetKeyState(VK_MENU) < 0 then Include(Result, msAlt);
  if (GetKeyState(VK_LWIN) < 0) or (GetKeyState(VK_RWIN) < 0) then Include(Result, msWin);
end;

function GetModifyKeys: Word;
begin
  Result := 0;
  if GetKeyState(VK_SHIFT) < 0 then Inc(Result, MOD_SHIFT);
  if GetKeyState(VK_CONTROL) < 0 then Inc(Result, MOD_CONTROL);
  if GetKeyState(VK_MENU) < 0 then Inc(Result, MOD_ALT);
  if (GetKeyState(VK_LWIN) < 0) or (GetKeyState(VK_RWIN) < 0) then Inc(Result, MOD_WIN);
end;

{ TGlobalHotkey }

constructor TGlobalHotkey.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Width := 121;
  Height := 25;
  TabStop := True;
  ParentColor := False;
  AutoSelect := False;
  ReadOnly := True;
  Text := srNone;
  FHotKey := 0;
end;

procedure TGlobalHotkey.DoEnter;
begin
  inherited DoEnter;

  SelStart := Length(Text);
end;

procedure TGlobalHotkey.KeyDown(var Key: Word; Shift: TShiftState);
var
  VirtualKey: Word;
  Modifier: TModifyState;
begin
  inherited KeyDown(Key, Shift);

  VirtualKey := Key;
  Modifier := [];
  if (ssShift in Shift) and (Key <> VK_SHIFT) then Include(Modifier, msShift);
  if (ssAlt in Shift) and (Key <> VK_MENU) then Include(Modifier, msAlt);
  if (ssCtrl in Shift) and (Key <> VK_CONTROL) then Include(Modifier, msCtrl);
  if (GetKeyState(VK_LWIN) < 0) and (Key <> VK_LWIN) then Include(Modifier, msWin);
  if (GetKeyState(VK_RWIN) < 0) and (Key <> VK_RWIN) then Include(Modifier, msWin);
  FHotKey := Hotkeys.HotKey(VirtualKey, Modifier);
  Text := HotKeyToText(FHotKey);
  Key := 0;
  SelStart := Length(Text);
end;

procedure TGlobalHotkey.Change;
begin
  inherited Change;

  if Text = '' then
    Text := srNone;
end;

procedure TGlobalHotkey.SetHotKey(Value: TShortCut);
begin
  if Value <> FHotKey then
  begin
    FHotKey := Value;
    Text := HotKeyToText(FHotKey);
  end;
end;

procedure TGlobalHotkey.ClearHotKey;
begin
  SetHotKey(0);
end;

{ TGlobalHotkeyAction }

constructor TGlobalHotkeyAction.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FHandle := AllocateHWnd(WndProc);
  FRegistered := False;
  FHotKey := 0;
end;

procedure TGlobalHotkeyAction.WndProc(var Message: TMessage);
begin
  with Message do
    if Msg = WM_HOTKEY then
    begin
      try
        Execute;
      except
        Application.HandleException(Self);
      end;
    end
    else
    begin
      Result := DefWindowProc(FHandle, Msg, WParam, LParam);
    end;
end;

procedure TGlobalHotkeyAction.InstallHotKey(ShortCut: TShortCut);
var
  VirtualKey,
  Modifier: Word;
begin
  HotKeyToKey(ShortCut, VirtualKey, Modifier);
  if RegisterHotKey(FHandle, 0, Modifier, VirtualKey) then
    FRegistered := True
  else
    raise Exception.Create(SysErrorMessage(GetLastError));
end;

procedure TGlobalHotkeyAction.UninstallHotKey;
begin
  if UnregisterHotKey(FHandle, 0) then
    FRegistered := False
  else
    raise Exception.Create(SysErrorMessage(GetLastError));
end;

procedure TGlobalHotkeyAction.SetHotKey(Value: TShortCut);
begin
  if Value = FHotKey then Exit;

  if Value = 0 then
  begin
    UninstallHotKey;
    //! Enabled := False;
  end
  else
  begin
    if FRegistered then
      UninstallHotKey;
    InstallHotKey(Value);
    //! Enabled := True;
  end;
  FHotKey := Value;
  Update;
end;

destructor TGlobalHotkeyAction.Destroy;
begin
  DeallocateHWnd(FHandle);

  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TGlobalHotkey]);
  RegisterActions('HotKey', [TGlobalHotkeyAction], nil);
end;

end.
