(* TUpDownEdit, TThumbEdit, TNumericEdit

Ver, 1.00 2007/07/20 ^B
Ver, 1.01 2007/09/17 RangeCheck vpeBǉB
Ver, 1.02 2008/12/10 jbgύXATNumericEdit B
Ver, 1.03 2014/10/20 TNumericEdit ɕ_lΉB
Ver, 1.04 2016/09/20 BiDiMode ̍XVɂΉBSetName CB
Ver, 1.05 2017/03/19 SʉBTThumbEdit B
Ver, 1.06 2017/05/26 TUpDownEdit.EndUpdate CBfcAllowPositive ǉB
Ver, 1.07 2017/07/26 TUpDownEdit.DoVerify CB
Ver, 1.08 2017/08/06 TInternalUpDown.Thousands p~BRelation \bhǉBقACƒB

TUpDownEdit
Abv_E{^̐l̓GfBbgB
TEdit + TUpDown ̃ZbgB
XE2 ȍ~ TUpDown ̎dlςHText - Position Ԃ̍XVɍsȂ݂ǁB

\bh
BeginUpdate:  Text, Value ̍XVJnBOnCange, OnVerify Cxg̔}~B
EndUpdate;    Text, Value ̍XVIBOnVerify Cxg𔭐B
UpdateCount:  BeginUpdate ̌Ăяo񐔁B
Relation:     Text, UpDown.Position ̔rB

vpeB
Value;      ݒlBText  UpDown.Position 𓯎ɐݒ肷B
Alignment;  l̑B
UpDown;     Abv_E{^Bl̏㉺͂ŎwB
Filters:    ͕̐BTEdit.NumbersOnly gB

Cxg
OnChange:   TEdit.OnCange ƓAUpDown.Postion ̕ύXł͔ȂB
OnCount:    UpDown.Positon ςƂɔ邪AText ̕ύXł͔ȂB
OnVerify:   [`gݍ݂ OnChange ƓBOnCange ܂ OnCount ̔ɔB

̂ق̃vpeBA\bhACxg TEdit, TUpDown ƓB

TThumbEdit
gbNo[(ڂ̓Q[W݂)l̓GfBbgB
͓̂قA㉺L[EzC[] LineSize, PageUp/Down L[ PageSize,
~h{^hbOŃJ[\ʒu Position ړłB

\bh
BeginUpdate:  Text, Value ̍XVJnBOnCange, OnVerify Cxg̔}~B
EndUpdate;    Text, Value ̍XVIBOnVerify Cxg𔭐B
UpdateCount:  BeginUpdate ̌Ăяo񐔁B
Relation:     Text, Position ̔rB

vpeB
BackColor:  GfBbg̐FB
ForeColor:  o[̐FB
Min:        o[̉B
Max:        o[̏B
Position:   o[݈̌ʒuB
LineSize:   ㉺L[ł Position ̕ωʁB
PageSize:   PageUp/Down L[ł Position ̕ωʁB
ArrowKeys:  TUpDown.ArrowKeys ƓB
Filters:    ͕̐BTEdit.NumbersOnly gB

Cxg
OnChange:   TEdit.OnCange ƓAPostion ̕ύXł͔ȂB
OnCount:    Positon ςƂɔ邪AText ̕ύXł͔ȂB
OnVerify:   [`gݍ݂ OnChange ƓBOnCange ܂ OnCount ̔ɔB

̂ق̃vpeBA\bhACxg TEdit ƓB

TNumericEdit
lϊT|[gGfBbgB

\bh
IsCurrency: eLXgl`FbNB
IsFloat:    eLXg_l`FbNB
IsInteger:  eLXgl`FbNB

vpeB
Curr:         eLXg̎lB
Float:        eLXg̕_lB
Int:          eLXg̐lB
FloatFormat:  _l̐`@BSystem.SysUtils.FormatFloat ֐ Format ƓB
RoundingMode: lւ̕ϊ̊ۂߕB
Filters:    ͕̐BTEdit.NumbersOnly gB

̂ق̃vpeBA\bhACxg TEdit ƓB

  e퐔l̓GfBbg *)

unit NumEdits;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Vcl.Graphics,
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls, System.Math;

type
  TFilterChar = (
    fcAllowDecimal,   //['0'..'9']
    fcAllowPositive,  //fcAllowDecimal + ['+']
    fcAllowNegative,  //fcAllowDecimal + ['-']
    fcAllowHexdigit,  //fcAllowDecimal + ['$', 'X', 'x', 'A'..'F', 'a'..'f']
    fcAllowReal,      //fcAllowDecimal + ['.', 'E', 'e']
    fcAllowSeparater, //fcAllowDecimal + [',']
    fcRejectProcess   //TFilterChar ȊO̕܂܂镶͏ȂB
  );
  TFilterChars = set of TFilterChar;

  TNumericallyRelationship = (
    nrAccord,     //Text  Position vB
    nrDisaccord,  //Text  Position svB
    nrNonNumber   //Text ł͂ȂB
  );

  //[`gݍ݂ OnChange
  TNumericallyVerifyEvent = procedure(Sender: TObject;
    var AText: string; var APosition: Integer; Relation: TNumericallyRelationship) of object;

  TCustomNumEdit = class(TCustomEdit)
  private
    { Private 錾 }
    FFilters: TFilterChars;
    procedure WMPaste(var Msg: TMessage); message WM_PASTE;
  protected
    { Protected 錾 }
    procedure KeyPress(var Key: Char); override;
    property Filters: TFilterChars read FFilters write FFilters default [];
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
  end;

  TUpDownEdit = class;

  TInternalUpDown = class(TCustomUpDown)
  private
    { Private 錾 }
    function GetPosition: Integer;
    procedure SetPosition(Value: Integer);
    procedure WMHScroll(var Message: TWMHScroll); message CN_HSCROLL;
    procedure WMVScroll(var Message: TWMVScroll); message CN_VSCROLL;
  protected
    { Protected 錾 }
    function CanChange: Boolean; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property ArrowKeys;
    property Hint;
    property Min;
    property Max;
    property Increment;
    property ParentShowHint;
    property PopupMenu;
    property Position read GetPosition write SetPosition;
    property ShowHint;
    property TabOrder;
    property TabStop;
    //! property Thousands;
    property Wrap;
  end;

  TUpDownEdit = class(TCustomNumEdit)
  private
    { Private 錾 }
    FUpDown: TInternalUpDown;
    FUpdateCount: Integer;
    FOnCount: TNotifyEvent;
    FOnVerify: TNumericallyVerifyEvent;
    function GetValue: Integer;
    procedure SetValue(Value: Integer);
    procedure CMEnabledChanged(var Msg: TMessage); message CM_ENABLEDCHANGED;
    procedure CMVisibleChanged(var Msg: TMessage); message CM_VISIBLECHANGED;
    procedure CMDiBiModeChanged(var Message: TMessage); message CM_BIDIMODECHANGED;
  protected
    { Protected 錾 }
    procedure SetParent(AParent: TWinControl); override;
    procedure SetName(const Value: TComponentName); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Change; override;
    procedure DoVerify; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer; AHeight: Integer); override;
    procedure BeginUpdate;
    Procedure EndUpdate;
    function Relation: TNumericallyRelationship;
    property UpdateCount: Integer read FUpdateCount;
    property Value: Integer read GetValue write SetValue;
  published
    { Published 錾 }
    property UpDown: TInternalUpDown read FUpDown;
    property OnCount: TNotifyEvent read FOnCount write FOnCount;
    property OnVerify: TNumericallyVerifyEvent read FOnVerify write FOnVerify;
    property Filters;

    property Align;
    property Alignment;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    //! property NumbersOnly;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TThumbEdit = class(TCustomNumEdit)
  private
    { Private 錾 }
    FBrush: HBRUSH;
    FForeColor: TColor;
    FMin,
    FMax,
    FPosition,
    FLineSize,
    FPageSize: Integer;
    FArrowKeys: Boolean;
    FTracking: Boolean;
    FUpdateCount: Integer;
    FOnCount: TNotifyEvent;
    FOnVerify: TNumericallyVerifyEvent;
    function GetBackColor: TColor;
    procedure SetBackColor(Value: TColor);
    procedure SetForeColor(Value: TColor);
    procedure SetMin(Value: Integer);
    procedure SetMax(Value: Integer);
    procedure SetPosition(Value: Integer);
  protected
    { Protected 錾 }
    FBitmap: TBitmap;
    procedure Resize; override;
    procedure Change; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    procedure WndProc(var Message: TMessage); override;
    procedure FillBitmap;
    procedure UpdateBitmap;
    procedure DoVerify; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetPositionAt(X, Y: Integer): Integer;
    procedure BeginUpdate;
    Procedure EndUpdate;
    function Relation: TNumericallyRelationship;
    property UpdateCount: Integer read FUpdateCount;
  published
    { Published 錾 }
    property BackColor: TColor read GetBackColor write SetBackColor default clWindow;
    property ForeColor: TColor read FForeColor write SetForeColor default clGradientActiveCaption;
    property Min: Integer read FMin write SetMin default 0;
    property Max: Integer read FMax write SetMax default 100;
    property Position: Integer read FPosition write SetPosition default 0;
    property LineSize: Integer read FLineSize write FLineSize default 1;
    property PageSize: Integer read FPageSize write FPageSize default 2;
    property ArrowKeys: Boolean read FArrowKeys write FArrowKeys default True;
    property OnCount: TNotifyEvent read FOnCount write FOnCount;
    property OnVerify: TNumericallyVerifyEvent read FOnVerify write FOnVerify;
    property Filters;

    property Align;
    property Alignment;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    //! property NumbersOnly;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TNumericEdit = class(TCustomNumEdit)
  private
    { Private 錾 }
    FRoundingMode: TFPURoundingMode;
    FFloatFormat: string;
    function GetCurr: Currency;
    procedure SetCurr(Value: Currency);
    function GetFloat: Extended;
    procedure SetFloat(Value: Extended);
    function GetInt: Integer;
    procedure SetInt(Value: Integer);
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    function IsCurrency: Boolean;
    function IsFloat: Boolean;
    function IsInteger: Boolean;
    property Curr: Currency read GetCurr write SetCurr;
    property Float: Extended read GetFloat write SetFloat;
    property Int: Integer read GetInt write SetInt;
  published
    { Published 錾 }
    property FloatFormat: string read FFloatFormat write FFloatFormat;
    property RoundingMode: TFPURoundingMode read FRoundingMode write FRoundingMode default rmNearest;
    property Filters;

    property Align;
    property Alignment;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    //! property NumbersOnly;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

function MatchesFilter(C: Char; Filters: TFilterChars): Boolean;
function FilterConversion(const Src: string; var Dest: string; Filters: TFilterChars): Boolean;
function SameNumerically(S: string; V: Integer): TNumericallyRelationship;

procedure Register;

implementation

uses
  Vcl.Clipbrd, System.Types;

{ Routine }

//C  Filters ѕҏWV[gJbgɊ܂܂邩`FbNB
function MatchesFilter(C: Char; Filters: TFilterChars): Boolean;
var
  Filter: TFilterChar;
begin
  Result := (Filters = []) or CharInSet(C, [#08, #27, ^A, ^C, ^V, ^X, ^Z]);
  if not Result then
  begin
    if CharInSet(C, ['0'..'9']) then
      Result := True
    else
      for Filter in Filters do
      begin
        case Filter of
          fcAllowPositive:  if CharInSet(C, ['+']) then Result := True;
          fcAllowNegative:  if CharInSet(C, ['-']) then Result := True;
          fcAllowHexdigit:  if CharInSet(C, ['$', 'X', 'x', 'A'..'F', 'a'..'f']) then Result := True;
          fcAllowReal:      if CharInSet(C, ['.', 'E', 'e']) then Result := True;
          fcAllowSeparater: if CharInSet(C, [',']) then Result := True;
        end;
        if Result then Break;
      end;
  end
end;

//Src  Dest  Filters Ɋ܂܂ȂăRs[Bꍇ͐^ԂB
function FilterConversion(const Src: string; var Dest: string; Filters: TFilterChars): Boolean;
var
  Buf: string;
  i: Integer;
begin
  Result := False;
  if Filters <> [] then
  begin
    Buf := '';
    for i := 1 to Length(Src) do
    begin
      if MatchesFilter(Src[i], Filters) then
        Buf := Buf + Src[i]
      else
      begin
        Result := True;
        if fcRejectProcess in Filters then
          Exit;
      end;
    end;
    Dest := Buf;
  end
  else
    Dest := Src;
end;

//S 𐔒lɕϊ I ƈv邩rB
function SameNumerically(S: string; V: Integer): TNumericallyRelationship;
var
  i: Integer;
begin
  if TryStrToInt(S, i) then
  begin
    if i = V then
      Result := nrAccord
    else
      Result := nrDisaccord;
  end
  else
    Result := nrNonNumber;
end;

{ TCustomNumEdit }

constructor TCustomNumEdit.Create(AOwner: TComponent);
begin
  inherited;

  FFilters := [];
end;

procedure TCustomNumEdit.KeyPress(var Key: Char);
begin
  inherited;

  if not MatchesFilter(Key, Filters) then
  begin
    MessageBeep(0);
    Key := #0;
  end;
end;

procedure TCustomNumEdit.WMPaste(var Msg: TMessage);
var
  s: string;
begin
  if Filters <> [] then
  begin
    if Clipboard.HasFormat(CF_TEXT) then
    begin
      s := Clipboard.AsText;
      if FilterConversion(s, s, Filters) then
      begin
        MessageBeep(0);
        if fcRejectProcess in Filters then
          Exit;
      end;
      SelText := s;
    end;
  end
  else
    inherited;
end;

{ TInternalUpDown }

constructor TInternalUpDown.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Thousands := False;
  SetSubComponent(True);
end;

function TInternalUpDown.CanChange: Boolean;
begin
  Result := inherited CanChange;

  if Result then
    TUpDownEdit(Owner).BeginUpdate;
end;

function TInternalUpDown.GetPosition: Integer;
begin
  Result := inherited Position;
end;

procedure TInternalUpDown.SetPosition(Value: Integer);
begin
  inherited Position := Value;

  with Owner as TUpDownEdit do
  begin
    if Assigned(FOnCount) then
      FOnCount(Self);
    EndUpdate;
  end;
end;

procedure TInternalUpDown.WMHScroll(var Message: TWMHScroll);
begin
  inherited;

  with Owner as TUpDownEdit do
  begin
    if Assigned(FOnCount) then
      FOnCount(Self);
    EndUpdate;
  end;
end;

procedure TInternalUpDown.WMVScroll(var Message: TWMVScroll);
begin
  inherited;

  with Owner as TUpDownEdit do
  begin
    if Assigned(FOnCount) then
      FOnCount(Self);
    EndUpdate;
  end;
end;

{ TUpDownEdit }

constructor TUpDownEdit.Create(AOwner: TComponent);
begin
  inherited;

  FUpDown := TInternalUpDown.Create(Self);
  FUpDown.SetSubComponent(True);
  FFilters := [];
  FUpdateCount := 0;
  Text := '0';
end;

procedure TUpDownEdit.SetParent(AParent: TWinControl);
begin
  inherited;

  if Assigned(UpDown) then
  begin
    UpDown.Parent := Self.Parent;
    UpDown.Associate := Self;
  end;
end;

procedure TUpDownEdit.SetName(const Value: TComponentName);
begin
  inherited;

  if Assigned(UpDown) and (csDesigning in ComponentState) then
    UpDown.Name := 'InternalUD';
end;

procedure TUpDownEdit.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;

  if (AComponent = FUpDown) and (Operation = opRemove) then
    FUpDown := nil;
end;

procedure TUpDownEdit.Change;
begin
  inherited Changed; //OnChange Ȃ悤 TCustomEdit.Change oCpXB

  if UpdateCount = 0 then
  begin
    BeginUpdate;
    try
      if Assigned(OnChange) then
        OnChange(Self);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TUpDownEdit.DoVerify;
var
  s: string;
  i: Integer;
begin
  if Assigned(FUpDown) and Assigned(FOnVerify) then
  begin
    Inc(FUpdateCount);
    try
      s := Text;
      i := UpDown.Position;
      FOnVerify(Self, s, i, SameNumerically(s, i));
      if (s <> Text) or (i <> UpDown.Position) then
      begin
        UpDown.Associate := nil;
        try
          Text := s;
          UpDown.Position := i;
        finally
          UpDown.Associate := Self;
        end;
      end;
    finally
      if FUpdateCount > 0 then
        Dec(FUpdateCount);
    end;
  end;
end;

procedure TUpDownEdit.SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer; AHeight: Integer);
begin
  inherited;

  if Assigned(UpDown) then
    UpDown.SetBounds(Left + Width, Top, FUpDown.Width, Height);
end;

procedure TUpDownEdit.CMEnabledChanged(var Msg: TMessage);
begin
  inherited;

  if Assigned(UpDown) then
    UpDown.Enabled := Enabled;
end;

procedure TUpDownEdit.CMVisibleChanged(var Msg: TMessage);
begin
  inherited;

  if Assigned(UpDown) then
    UpDown.Visible := Visible;
end;

procedure TUpDownEdit.CMDiBiModeChanged(var Message: TMessage);
begin
  inherited;

  if Assigned(UpDown) then
    UpDown.BiDiMode := BiDiMode;
end;

procedure TUpDownEdit.BeginUpdate;
begin
  Inc(FUpdateCount);
end;

function TUpDownEdit.Relation: TNumericallyRelationship;
begin
  Result := SameNumerically(Text, UpDown.Position);
end;

Procedure TUpDownEdit.EndUpdate;
begin
  //InternalUD ̉e BeginUpdate - EndUpdate ΂ŎsƂ͌ȂB
  if FUpdateCount > 0 then
  begin
    Dec(FUpdateCount);
    if not (csLoading in ComponentState) and (FUpdateCount = 0) then
      DoVerify;
  end;
end;

function TUpDownEdit.GetValue: Integer;
begin
  if Assigned(UpDown) then
    Result := UpDown.Position
  else
    Result := StrToInt(Text);
end;

procedure TUpDownEdit.SetValue(Value: Integer);
begin
  BeginUpdate;
  try
    if Assigned(UpDown) then
      UpDown.Position := Value;
    Text := IntToStr(Value);
  finally
    EndUpdate;
  end;
end;

destructor TUpDownEdit.Destroy;
begin
  if Assigned(UpDown) then
    FUpDown.Destroy;

  inherited;
end;

{ TThumbEdit }

constructor TThumbEdit.Create(AOwner: TComponent);
begin
  inherited;

  FForeColor := clGradientActiveCaption;
  FMin := 0;
  FMax := 100;
  FPosition := 0;
  FLineSize := 1;
  FPageSize := 2;
  FArrowKeys := True;
  FFilters := [];
  FTracking := False;
  FUpdateCount := 0;
  Text := '0';
end;

function TThumbEdit.GetPositionAt(X, Y: Integer): Integer;
begin
  Result := Round(X / (FBitmap.Width / (Max - Min)));
  if Result < Min then
    Result := Min;
  if Max < Result then
    Result := Max;
end;

procedure TThumbEdit.Resize;
begin
  inherited;

  UpdateBitmap;
end;

procedure TThumbEdit.Change;
var
  i: Integer;
begin
  inherited Changed;

  if FUpdateCount = 0 then
  begin
    BeginUpdate;
    try
      if TryStrToInt(Text, i) then
        Position := i;

      if Assigned(OnChange) then
        OnChange(Self);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TThumbEdit.DoVerify;
var
  s: string;
  i: Integer;
begin
  if Assigned(FOnVerify) then
  begin
    Inc(FUpdateCount);
    try
      s := Text;
      i := Position;
      FOnVerify(Self, s, i, SameNumerically(s, i));
      if (s <> Text) or (i <> Position) then
      begin
        Text := s;
        Position := i;
      end;
    finally
      Dec(FUpdateCount);
    end;
  end;
end;

procedure TThumbEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if ArrowKeys then
  begin
    if Key = VK_UP then
      Position := Position + LineSize
    else if Key = VK_DOWN then
      Position := Position - LineSize
    else if Key = VK_PRIOR then
      Position := Position + PageSize
    else if Key = VK_NEXT then
      Position := Position - PageSize
    else
      inherited;
  end
  else
    inherited;
end;

procedure TThumbEdit.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if Button = mbMiddle then
  begin
    ReleaseCapture;
    if not Focused then
      SetFocus;

    FTracking := True;
    SetCapture(Handle);
    Position := GetPositionAt(X, Y);
  end;
end;

procedure TThumbEdit.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if FTracking then
  begin
    ReleaseCapture;
    FTracking := False;
  end;
end;

procedure TThumbEdit.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if FTracking then
    Position := GetPositionAt(X, Y);
end;

function TThumbEdit.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);
  if not Result then
  begin
    Position := Position - LineSize;
    Result := True;
  end;
end;

function TThumbEdit.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);
  if not Result then
  begin
    Position := Position + LineSize;
    Result := True;
  end;
end;

procedure TThumbEdit.WndProc(var Message: TMessage);
begin
  inherited;

  case Message.Msg of
    CN_CTLCOLOREDIT, CN_CTLCOLORSTATIC:
    begin
      if (Message.LParam = Integer(Handle)) and (FBrush <> 0) then
      begin
        SetBkMode(Message.WParam, TRANSPARENT);
        Message.Result := FBrush;
      end;
    end;
  end;
end;

procedure TThumbEdit.BeginUpdate;
begin
  Inc(FUpdateCount);
end;

Procedure TThumbEdit.EndUpdate;
begin
  Dec(FUpdateCount);
  if not (csLoading in ComponentState) and (FUpdateCount = 0) then
    DoVerify;
end;

function TThumbEdit.Relation: TNumericallyRelationship;
begin
  Result := SameNumerically(Text, Position);
end;

procedure TThumbEdit.FillBitmap;
var
  w: Integer;
begin
  with FBitmap do
  begin
    w := Round((Width / (Max - Min)) * Position);

    Canvas.Pen.Color := ForeColor;
    Canvas.Brush.Color := ForeColor;
    Canvas.Rectangle(Bounds(0, 0, w, Height));

    Canvas.Pen.Color := BackColor;
    Canvas.Brush.Color := BackColor;
    Canvas.Rectangle(Bounds(w, 0, Width - w, Height));
  end;
end;

procedure TThumbEdit.UpdateBitmap;
begin
  if FBitmap = nil then
  begin
    FBitmap := TBitmap.Create;
    FBitmap.PixelFormat := pf32bit;
  end;

  if HandleAllocated then
  begin
    FBitmap.SetSize(ClientWidth, ClientHeight);
    FillBitmap;
    FBrush := CreatePatternBrush(FBitmap.Handle);
  end;
  Refresh;
end;

function TThumbEdit.GetBackColor: TColor;
begin
  Result := Color;
end;

procedure TThumbEdit.SetBackColor(Value: TColor);
begin
  if Value <>Color then
  begin
    Color := Value;
    UpdateBitmap;
  end;
end;

procedure TThumbEdit.SetForeColor(Value: TColor);
begin
  if Value <> FForeColor then
  begin
    FForeColor := Value;
    UpdateBitmap;
  end;
end;

procedure TThumbEdit.SetMin(Value: Integer);
begin
  if Value <> FMin then
  begin
    FMin := Value;
    if FMax <= FMin then
      FMax := FMin + 1;
    if FPosition < FMin then
      FPosition := FMin;
    UpdateBitmap;
  end;
end;

procedure TThumbEdit.SetMax(Value: Integer);
begin
  if Value <> FMax then
  begin
    FMax := Value;
    if FMax <= FMin then
      FMin := FMax - 1;
    if FPosition > FMax then
      FPosition := FMax;
    UpdateBitmap;
  end;
end;

procedure TThumbEdit.SetPosition(Value: Integer);
begin
  if Value < FMin then
    Value := FMin;
  if FMax < Value then
    Value := FMax;
  if Value <> FPosition then
  begin
    FPosition := Value;
    UpdateBitmap;

    if FUpdateCount = 0 then
    begin
      BeginUpdate;
      try
        Text := IntToStr(Position);
        if Assigned(FOnCount) then
          FOnCount(Self);
      finally
        EndUpdate;
      end;
    end;
  end;
end;

destructor TThumbEdit.Destroy;
begin
  if FBrush <> 0 then
    DeleteObject(FBrush);
  if Assigned(FBitmap) then
    FBitmap.Free;

  inherited;
end;

{ TNumericEdit }

constructor TNumericEdit.Create(AOwner: TComponent);
begin
  inherited;

  FRoundingMode := rmNearest;
  FFloatFormat := '';
  Text := '0';
end;

function TNumericEdit.IsCurrency: Boolean;
var
  f: Currency;
begin
  Result := TryStrToCurr(Text, f);
end;

function TNumericEdit.IsFloat: Boolean;
var
  f: Extended;
begin
  Result := TryStrToFloat(Text, f);
end;

function TNumericEdit.IsInteger: Boolean;
var
  i: Integer;
begin
  Result := TryStrToInt(Text, i);
end;

function TNumericEdit.GetCurr: Currency;
begin
  Result := StrToCurr(Text);
end;

procedure TNumericEdit.SetCurr(Value: Currency);
begin
  Text := CurrToStr(Value);
end;

function TNumericEdit.GetFloat: Extended;
begin
  Result := StrToFloat(Text);
end;

procedure TNumericEdit.SetFloat(Value: Extended);
begin
  Text := FormatFloat(FloatFormat, Value);
end;

function TNumericEdit.GetInt: Integer;
begin
  Result := 0;
  try
    Result := StrToInt(Text);
  except
    on E: EConvertError do
    begin
      case FRoundingMode of
        rmNearest: Result := Round(StrToCurr(Text));
        rmDown: Result := Floor(StrToCurr(Text));
        rmUp: Result := Ceil(StrToCurr(Text));
        rmTruncate: Result := Trunc(StrToCurr(Text));
      end;
    end;
  end;
end;

procedure TNumericEdit.SetInt(Value: Integer);
begin
  Text := IntToStr(Value);
end;

procedure Register;
begin
  RegisterComponents('Samples', [TUpDownEdit, TThumbEdit, TNumericEdit]);
end;

end.
